
// ⺻ 
#define	__STDIO_FDEVOPEN_COMPAT_12


#include <stdint.h>
#include <stdio.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#include "tftlcd.h"

#include "image.h"
#include "touch.h"

#include "SPI_routines.h"
#include "SD_routines.h"
#include "UART_routines.h"
#include "FAT32.h"




void init()
{
   cli();
   unsigned char RXD;  
   DDRA=0xff;
   PORTB = 0xFE;
   DDRB  = 0xF7;
////MISO line i/p, rest o/p
	DDRC=0xff;
	DDRD=0xfB;
	DDRE=0x7f;
	DDRF=0xff;

	PORTD= 0xff;
	PORTE= 0xff;
// Timer/Counter0 (Overflow)
	ASSR=0x00;
	TCCR0 = 0x07;						// system clock,16,000,000 / 1024 = 15.625Khz
	TCNT0 = 99;						// 255-156 = 99	
	OCR0=0x00;
	TIMSK |= 0x01;						// TIMER0 ͷƮ 㰡
// Baud9600   103  //=>11.0592M (71), 16M => 103
// Baud384000   25  //=>11.0592M(17) , 25
  UBRR0H = 0;                                   //16M 25=> 38400 bps
  UBRR0L = 25;   //8M=>12
  UCSR0A = 0x00;                                // asynchronous normal mode
  UCSR0B = 0x18;                                // interrupt enable, 8 data  18 , 98
  UCSR0C = 0x06;                                // no parity, 1 stop, 8 data
 RXD = UDR0;
//fdevopen(putchar_0,getchar_0,0);
 //  sei();

}



/*
void uartdisplay(void)
{

    printf("%s","****  signaltech ver 0.1  2009/10/14 **\n");
	printf("%s","*  TFT LCD Test Main UART0 38400bps   *\n");
	printf("%s","*  1  =>  red_set              \n");
	printf("%s","*  2  =>  Dot test             \n");
	printf("%s","*  3  =>  8 DEMO 		  	    \n");
	printf("%s","*  4  =>  16 DEMO      		\n");
	printf("%s","*  C,c =>  Clear  	 	    	\n");
	printf("%s","*  L,l =>  Dot test		    \n");
	printf("%s","*  R,r =>  Rectangle  		 	\n");
	printf("%s","***************************************\n");
	printf("test number or  character input :\n");

 }
 	
*/


int main(void)
{

unsigned char option, error, data, FAT32_active;
unsigned int i;
unsigned char fileName[13];


 // unsigned char RXD;  
  init();
  TSC2003_Setup();
 // printf("%s","****  signaltech ver 0.1  2009/11/20 **\n");
//	printf("%s","*  TFT LCD Test Main UART0 38400bps   *\n");
//		stdout = &device1;   
 spi_init();

 
 TFT_SET();
 LCD_ON();
 lcd_cmd(0x0202);
  
Demo_display_8_color(); 


TX_NEWLINE;
transmitString("***********************************");
TX_NEWLINE;
transmitString(" Signaltech microSD Card Testing..");
TX_NEWLINE;
transmitString("***********************************");
TX_NEWLINE;




SD_init();
SPI_HIGH_SPEED;	//SCK - 4 MHz
//_delay_ms(1);   //some delay

 //uartdisplay();
	tftlcdPutStr(25,5,"BBB",0x08e0);
		tftlcdPutStr(40,5,"iii",0x19e0);

////////////////////////////////////////////////////////////
FAT32_active = 1;
error = getBootSectorData (); //read boot sector and keep necessary data in global variables
if(error) 	
{
  transmitString("FAT32 not found!");  //FAT32 incompatible drive
  FAT32_active = 0;
}

/////////////////////////////////////
	
	while(1)
	{ 

///////////////////////////////////
TX_NEWLINE;
transmitString("Press any key...");
TX_NEWLINE;
option = receiveByte();
TX_NEWLINE;
transmitString("> 0 : Erase Blocks");
TX_NEWLINE;
transmitString("> 1 : Write single Block");
TX_NEWLINE;
transmitString("> 2 : Read single Block");

#ifndef FAT_TESTING_ONLY
TX_NEWLINE;
transmitString("> 3 : Write multiple Blocks");
TX_NEWLINE;
transmitString("> 4 : Read multiple Blocks");
#endif


TX_NEWLINE;
transmitString("> 5 : Get file list");
TX_NEWLINE;
transmitString("> 6 : Read File");
TX_NEWLINE;
transmitString("> 7 : Write File");
TX_NEWLINE;
transmitString("> 8 : Delete File");
TX_NEWLINE;
transmitString("> 9 : Read SD Memory Capacity (Total/Free)");

TX_NEWLINE;
TX_NEWLINE;
transmitString("> Select Option (0-9): ");

/*WARNING: If option 0, 1 or 3 is selected, the card may not be detected by PC/Laptop again,
as it disturbs the FAT format, and you may have to format it again with FAT32.
This options are given for learnig the raw data transfer to & from the SD Card*/

option = receiveByte();
transmitByte(option);

if(option >=0x35 && option <=0x39)  //options 5 to 9 disabled if FAT32 not found
{
  if(!FAT32_active) 
  {
    TX_NEWLINE;
    TX_NEWLINE;
	transmitString("FAT32 options disabled!");
	continue;
  } 
}


if((option >= 0x30) && (option <=0x34)) //get starting block address for options 0 to 4
{
TX_NEWLINE;
TX_NEWLINE;
transmitString("Enter the Block number (0000-9999):");
data = receiveByte(); transmitByte(data);
startBlock = (data & 0x0f) * 1000;
data = receiveByte(); transmitByte(data);
startBlock += (data & 0x0f) * 100;
data = receiveByte(); transmitByte(data);
startBlock += (data & 0x0f) * 10;
data = receiveByte(); transmitByte(data);
startBlock += (data & 0x0f);
TX_NEWLINE;
}

totalBlocks = 1;

#ifndef FAT_TESTING_ONLY

if((option == 0x30) || (option == 0x33) || (option == 0x34)) //get total number of blocks for options 0, 3 or 4
{
TX_NEWLINE;
TX_NEWLINE;
transmitString("How many blocks? (000-999):");
data = receiveByte(); transmitByte(data);
totalBlocks = (data & 0x0f) * 100;
data = receiveByte(); transmitByte(data);
totalBlocks += (data & 0x0f) * 10;
data = receiveByte(); transmitByte(data);
totalBlocks += (data & 0x0f);
TX_NEWLINE;
}
#endif

///////////////////////////////////////////////////////////

if(com1_rx_flg){					// COM1  ˻
	 putchar(com1_rx_data);
		//	com1_rx_flg = 0;

	if(Touch_Data(30)){					// ġ  ˻ 300ms
//		printf("touch > (x)%d : (y)%d\r\n",Touch_X,Touch_Y);

	}

//	RXD = RX0_char_scan();
    switch(com1_rx_data)
  {


case '0': //error = SD_erase (block, totalBlocks);
          error = SD_erase (startBlock, totalBlocks);
          TX_NEWLINE;
          if(error)
              transmitString("Erase failed..");
          else
              transmitString("Erased!");
          break;

case '1': TX_NEWLINE;
          transmitString(" Enter text (End with ~):");
          i=0;
            do
            {
                data = receiveByte();
                transmitByte(data);
                buffer[i++] = data;
                if(data == 0x0d)
                {
                    transmitByte(0x0a);
                    buffer[i++] = 0x0a;
                }
                if(i == 512) break;
            }while (data != '~');

            error = SD_writeSingleBlock (startBlock);
            TX_NEWLINE;
            TX_NEWLINE;
            if(error)
                transmitString("Write failed..");
            else
                transmitString("Write successful!");
            break;

case '2': error = SD_readSingleBlock (startBlock);
          TX_NEWLINE;
          if(error)
            transmitString("Read failed..");
          else
          {
            for(i=0;i<512;i++)
            {
                if(buffer[i] == '~') break;
                transmitByte(buffer[i]);
            }
            TX_NEWLINE;
            TX_NEWLINE;
            transmitString("Read successful!");
          }

          break;
//next two options will work only if following macro is cleared from SD_routines.h
#ifndef FAT_TESTING_ONLY

case '3': 
          error = SD_writeMultipleBlock (startBlock, totalBlocks);
          TX_NEWLINE;
          if(error)
            transmitString("Write failed..");
          else
            transmitString("Write successful!");
          break;

case '4': error = SD_readMultipleBlock (startBlock, totalBlocks);
          TX_NEWLINE;
          if(error)
            transmitString("Read failed..");
          else
            transmitString("Read successful!");
          break;
#endif

case '5': TX_NEWLINE;
  		  findFiles(GET_LIST,0);
          break;

case '6': 
case '7': 
case '8': TX_NEWLINE;
		  TX_NEWLINE;
          transmitString("Enter file name: ");
          for(i=0; i<13; i++)
			fileName[i] = 0x00;   //clearing any previously stored file name
          i=0;
          while(1)
          {
            data = receiveByte();
            if(data == 0x0d) break;  //'ENTER' key pressed
			if(data == 0x08)	//'Back Space' key pressed
	 		{ 
	   			if(i != 0)
	   			{ 
	     			transmitByte(data);
					transmitByte(' '); 
	     			transmitByte(data); 
	     			i--; 
	   			} 
	   			continue;     
	 		}
			if(data <0x20 || data > 0x7e) continue;  //check for valid English text character
			transmitByte(data);
            fileName[i++] = data;
            if(i==13){transmitString(" file name too long.."); break;}
          }
          if(i>12) break;
       
	      TX_NEWLINE;
		  if(option == '6')
		     readFile( READ, fileName);
		  if(option == '7')
		  	 writeFile(fileName);
 		  if(option == '8')
		     deleteFile(fileName);
          break;

case '9': memoryStatistics();
          break;

default: TX_NEWLINE;
         TX_NEWLINE;
         transmitString(" Invalid option!");
         TX_NEWLINE;


         
		   } 
		   
		    //switch


/*

	case '1':
		{
	//	Putchxy(100,100,'1');
		tftlcdImageWrite(90, 100, 60, 75, mainImage);
		delay_ms(500);
	//	tftlcdImageWrite(90, 100, 60, 75, mainImage);
		delay_ms(500);delay_ms(500);delay_ms(500);
	//	red_set(); 	
		printf(" 1"); }
		break;
	case '2':  
		{   LCD_gotoxy(120,125);  LCD_Dot(0xffe0);
		LCD_gotoxy(120,130); LCD_Dot(0xffff); 
        LCD_gotoxy(120,135);  LCD_Dot(0xffe0); 
	  	printf(" 2 ");
	    }
		break;
	case '3':
		{Demo_display_8_color();  	printf(" 3"); }
		break;
	case '4':
		{Demo_display_16_gray(); 		printf(" 4"); }
		break;
	case '5':
		{
		LCD_Clear(); 	
		tftlcdWriteChar(1,1,"B",0x001f);//1
		tftlcdPutStr(240,1,"ABDEFH",0x001f);
		printf(" 3"); }
		break;
	case '6':
		{
		//	tftlcdPutStr(7,3,"ABCDEFGHIJKLMNOPQRSTUVWXYZ",0xf800 );
		//tftlcdPutStr(5,5,"AA",0x07e0);
		tftlcdPutStr(25,5,"BBB",0x08e0);
		tftlcdPutStr(40,5,"iii",0x19e0);
		tftlcdPutStr(60,5,"QQQ",0x3ae0);
		tftlcdPutStr(80,5,"WWW",0x9be0);
		tftlcdPutStr(100,5,"RRR",0xace0);
		tftlcdPutStr(160,5,"YYY",0xbde0);

		tftlcdPutStr(200,5,"(**Y",0xf800);
		tftlcdPutStr(240,5,"(..)",0x001f);
		tftlcdPutStr(280,5,"Y^^Y",0xffff);

		tftlcdPutStr(350,5,"HHHH",0xdee0);
		tftlcdPutStr(390,5,"B",0xefe0);
		tftlcdPutStr(395,5,"7",0xf7e0);
		printf(" 3"); }
		break;

	case '7':
		{
	tftlcdPutStr(5,5,"ABC",0x10e0);
	tftlcdPutStr(5,15,"DEF",0x21e0);
	tftlcdPutStr(5,25,"GHI",0x32e0);
	tftlcdPutStr(5,40,"JKL",0x43e0);
	tftlcdPutStr(5,85,"MNO",0x54e0);
	tftlcdPutStr(5,100,"PQR",0x65e0);
	tftlcdPutStr(5,145,"STU",0x76e0);


	tftlcdPutStr(5,230,"$$$$$$$$$$$",0x80e0);


 			
tftlcdPutStr(15,200,"@@@@@@@@@",0x97e0);



}
	break;


	case 'c':
	case 'C':
		{	LCD_Clear();   printf(" C");     }
	break;

	case 'l':
	case 'L':
	{	Line(0,0,399,239,GREEN);  	printf(" L");   }

     	break;


	case 'r':
	case 'R':
	{Rectangle(20,70,100,200,RED); 		printf(" R");  }
		break;

	case 't':
	case 'T':
		{Rectangle(20,70,100,200,RED); 		printf(" T");  }

	case '0':
		{ uartdisplay();		printf(" 0"); }
			break;


	default://  LCD_Clear();	
		{
	
		com1_rx_flg = 0;
	
		}

	//{ 	delay_ms(500); 	deLCD_Clear();lay_ms(500);	delay_ms(500);	     LCD_Clear();
 	// 	}
	//red_set();
		//delay_ms(500);	delay_ms(500);
		//Demo_display_16_gray();
 		//delay_ms(500);	delay_ms(500);
 }  //switch
*/


/*

if(Touch_Data(30)){					// ġ  ˻ 300ms
			printf("touch > (x)%d : (y)%d\r\n",Touch_X,Touch_Y);  }

*/



		}	
 }  //switch
}  //main
